local dbg = {}
-- ------------------------------------------------------------

function dbg.print_t( t )

   if t then
      for k,v in pairs( t ) do
          print( k, "-", v )
      end
   else
      print( "...empty." )
   end

end

function dbg.dump( t )

   print( "table: ", t )
   dbg.print_t( t )

   print( "meta: " )
   dbg.print_t( getmetatable( t ) )

end

-- ------------------------------------------------------------
return dbg