ver_001 = {}
-- -------------------------------------------------------------
tab = require( "tab" )

function ver_001.rawnew(class, object)

    return setmetatable(object or {}, class)
end

function ver_001.new(class, ...)

    local obj

    if class.__init then
         obj = class:__init(...)
    else 
       obj = tab.merge_toleft( class, ... )
       setmetatable( obj, { __index = class } )
    end
    
    return obj
end

function ver_001.initclass( class )

    if class == nil then class = {} end
    -- if class.__index == nil then class.__index = class end

    return class
end

local MetaClass = { __call = ver_001.new }

function ver_001.class(class)
    return setmetatable( ver_001.initclass(class), MetaClass )
end

-- -------------------------------------------------------------
return ver_001